#Data visualization
cars <- read.table("Cars.csv", header = TRUE, sep=";")
plot(cars$cena~cars$rok_vyroby)
plot(cars$objem~cars$vykon)
boxplot(cars$cena~cars$vyrobce, las = 2)
table(cars$vyrobce)


train <- read.table("Train.csv", header = TRUE, sep=";")
train <- train[which(train$uid==1),]


mdt <- merge(cars, train, by.x="id", by.y="oid")
plot(mdt$rating~mdt$vyrobce, las = 2)
plot(mdt$rating~mdt$model, las = 2)
plot(mdt$rating~mdt$rok_vyroby)
plot(mdt$rating~mdt$najete_km)
plot(mdt$rating~mdt$objem)
plot(mdt$rating~mdt$vykon)
plot(mdt$rating~mdt$spotreba)
plot(mdt$rating~mdt$cena)

abline(lm(mdt$rating~mdt$vykon))

#
dt1 <- c(0,1,2,3,4,5,6,7,8,9)
dt2 <- c(0,1,2,3,3.4,3.9,5,4.5,3,2)
df <- data.frame(dt1, dt2)

#data discretization
library(arules)
discretize(dt1)
discretize(dt1, method="frequency", categories=4)

#various regression methods
library(earth)

mod <- earth(dt2~dt1, df)
mod2 <- lm(dt2~dt1, df)

summary(mod)
summary(mod2)

plot(c(0,9), c(0,5), type = "n") 
plotmo(mod)
points(dt1, dt2, type = "p")
lines(dt1,dt2 ,col="green")

plot(c(0,9), c(0,5), type = "n") 
abline(mod2)
points(dt1, dt2, type = "p")
lines(dt1,dt2 ,col="green")

peak <- which.max(df$dt2)
lm1 <- lm(dt2~dt1, df[0:peak,])
lm2 <- lm(dt2~dt1, df[peak:nrow(df),])
plot(c(0,9), c(0,5), type = "n") 
abline(lm1)
abline(lm2)
points(dt1, dt2, type = "p")


peak <- which.max(df$dt2)
plot(c(0,9), c(0,5), type = "n") 
points(c(df$dt1[1], df$dt1[peak], df$dt1[nrow(df)]) , c(df$dt2[1], df$dt2[peak], df$dt2[nrow(df)]), type = "l")

points(dt1, dt2, type = "p")

# error on the train set

library(Metrics)
mae(predict(mod, newdata = df), dt2)
mae(predict(mod2, newdata = df), dt2)

dt3 <- c(
  predict(lm1, newdata = df[0:peak,]),
  predict(lm2, newdata = df[(peak+1):nrow(df),])
  )
mae(dt3, dt2)

rmse(dt3, dt2)

m <- cbind(predict(mod2, newdata = df), dt2) 
cor(m, method="kendall", use="pairwise") 


# error on the test set (your task) is more important due to overfitting

